global gDOAutoQuit, gDOUseLastInputStatus, gDOUseLastInputDir, gDOOutputDirType, gDOOutputDir

on DOprocessList DOfileList
  if not listp(DOfileList) then
    exit
  end if
  if DOfileList.count < 1 then
    exit
  end if
  closeDropFile()
  repeat with DOn = 1 to DOfileList.count
    DOfileToOpen = getAt(DOfileList, DOn)
    DOfxObj = xtra("FileXtra3").new()
    DOfileType = DOfxObj.fx_FileGetType(DOfileToOpen)
    DOfxObj = 0
    case DOfileType of
      ".dir", ".dcr", ".dxr":
        type = "movie"
      ".cst", ".cxt":
        type = "cast"
      otherwise:
        DOlog("Cannot parse " & QUOTE & DOfileType & QUOTE & " filetype", 6)
        exit
    end case
    the itemDelimiter = "\"
    DOinDir = item 1 to DOfileToOpen.items.count - 1 of DOfileToOpen & "\"
    case gDOOutputDirType of
      1:
        DOoutDir = the pathname
      2:
        DOoutDir = DOinDir
      3:
        if not dosIsFolderExist(string(gDOOutputDir)) then
          DOlog("The custom directory you supplied does not exist", 6)
          DOlog("Please enter a correct directory on the preferences tab.", 6)
          exit
        else
          DOoutDir = gDOOutputDir
        end if
    end case
    DOfileSize = dosGetFileSize(DOfileToOpen)
    the itemDelimiter = "\"
    DOoutputDrive = DOoutDir.item[1] & "\"
    DOfreeSpace = dosGetDriveInfo(DOoutputDrive, "free space")
    if DOfileSize > DOfreeSpace then
      DOlog("There is not enough free space to create the output file on " & DOoutputDrive & EMPTY, 6)
      DOlog("Filesize = " & DOfileSize & "Kb , Free space = " & DOfreeSpace & EMPTY, 6)
      exit
    end if
    the itemDelimiter = "\"
    DOfileNameWithoutPath = the last item in DOfileToOpen
    the itemDelimiter = "."
    DOfileNameNoExtension = item 1 to the number of items in DOfileNameWithoutPath - 1 of DOfileNameWithoutPath
    case type of
      "cast":
        AttachCastLib("inputCast", DOfileToOpen)
        DOlog("Opened cast " & DOfileToOpen)
        gOutputFileName = DOoutDir & "dirOpened output of " & DOfileNameNoExtension & ".cst"
        save(castLib("inputCast"), gOutputFileName)
        DOlog("Saved cast " & DOfileToOpen)
        DetachCastLib("inputCast")
        DOlog("Done!")
      "movie":
        DOoutputFileName = DOoutDir & "dirOpened output of " & DOfileNameNoExtension & ".dir"
        DOinputWindow = window("Input")
        DOinputWindow.rect = rect(-500, -500, -400, -400)
        DOinputWindow.fileName = DOfileToOpen
        open(DOinputWindow)
        DOlog("Opened movie " & DOfileToOpen)
        tell DOinputWindow
          saveMovie(DOoutputFileName)
        end tell
        DOlog("Saved movie to " & DOoutputFileName)
        forget(DOinputWindow)
        DOlog("Done!")
    end case
  end repeat
  if gDOUseLastInputStatus = 1 then
    gDOUseLastInputDir = DOinDir
    DOiniFileName = dosGetSpecialFolder("OS") & "\dirOpener.ini"
    DOsectionName = "USELASTINPUTDIR"
    DOkeyName = "DIR"
    dosWriteINI(DOiniFileName, DOsectionName, DOkeyName, gDOUseLastInputDir)
  end if
  if gDOAutoQuit = 1 then
    quit()
  end if
  startDropFile()
end
